PROGRAM SPIDISK;

// Arduino Nano
DEVICE = MEGA328P;

{$I mega328P_Register.INC}


CONST
  // Arduino Nano
  // TaktFrequenz in KHz
  TaktFrequenz : WORD = 20000;

  // bei 20,000 MHz -> 125.000
//  UBRR_VAL : Byte = 9;

  // bei 20,000 MHz -> 19.200
  UBRR_VAL : Byte = 64;


  LED_Gruen_Zaehler_Ende : Word = 10000;
  LED_Rot_Zaehler_Ende : Word = 10000;
  LED_Weiss_AT24C512_Zaehler_Ende : Word = 2000;
  LED_Weiss_W25Q64_Zaehler_Ende : Word = 2000;



VAR

  LED_Gruen[PortD,4] : bit; // LED_Gruen
  LED_Rot[PortD,  5] : bit; // LED_Rot
  LED_Gelb[PortD, 6] : bit; // LED_Gelb
  LED_Blau[PortD, 7] : bit; // LED_Blau

  LED_Weiss_AT24C512[PortB,0] : bit; // LED_Weiss_AT24C512
  LED_Weiss_W25Q64[PortB,1] : bit; // LED_Weiss_W25Q64



  Steuer_String : String[40];


  // Sektor-Puffer
  Sektor_Puffer : Array [0..127] of Byte;
  Sektor_Puffer_Zeiger : Word;

  // STD
  STD_Sektor_Nr : Word;
  STD_Spur_Nr : Word;





  WHO_AM_I_Schleife : Boolean;

  LED_Gruen_Zaehler,
  LED_Rot_Zaehler : Word;
  LED_Weiss_AT24C512_Zaehler,
  LED_Weiss_W25Q64_Zaehler : Word;



{$I SYSTEM.INC}

// {$I mega328P_UART_oI.INC}


{$I SPI_W25Q64.INC}

{$I I2C_AT24C512.INC}

{$I FLASH_Manager.INC}


{$I ITP3_CLI_PORT.INC}

{$I ITP3_CLI_PRG.INC}




// *** INITIALISIERUNG ***




procedure InitPorts;
begin


  DDRB  :=  %11101111;
  PortB :=  %00000100;

  DDRD  :=  %11111110;
  PortD :=  %10000000;


end InitPorts;






BEGIN

  InitPorts;

  ClearBit(LED_Rot);
  ClearBit(LED_Gelb);
  ClearBit(LED_Gruen);
  ClearBit(LED_Blau);


  ITP3_Client_Init;

  SetBit(LED_Gruen);


  // zuerst muss
  WHO_AM_I_Schleife:=true;

  while WHO_AM_I_Schleife do

    ITP3_Server_Abfrage;
    wait_ms(1);

  endwhile;

  ClearBit(LED_Gruen);



  Init_I2C;


  Init_GPIO;
  Init_SPI;


  // Initialisierung der EEPROMS
  SetBit(LED_Rot);


  INIT_FLASH_Manager;



  ClearBit(LED_Rot);




  LED_Gruen_Zaehler:=0;
  LED_Rot_Zaehler:=0;
  LED_Weiss_AT24C512_Zaehler:=0;
  LED_Weiss_W25Q64_Zaehler:=0;



  // Einschaltend der gelben LED als
  // Zeichen, dass der normale Betrieb
  // des Laufwerkes bereit ist
  SetBit(LED_Gelb);



  loop


    ITP3_Server_Abfrage;


    if LED_Gruen_Zaehler>0 then

      DEC(LED_Gruen_Zaehler);

      if LED_Gruen_Zaehler=0 then

        // LED-Gruen aus
        ClearBit(LED_Gruen);

        if LED_Rot_Zaehler=0 then
          // LED-Gelb ein
          SetBit(LED_Gelb);
        endif;

      endif; // if LED_Gruen_Zaehler=0

    endif;  // if LED_Gruen_Zaehler>0 then



    if LED_Rot_Zaehler>0 then

      DEC(LED_Rot_Zaehler);

      if LED_Rot_Zaehler=0 then

        // LED-Gruen aus
        ClearBit(LED_Rot);
        // LED-Gelb ein
        if LED_Rot_Zaehler=0 then
          // LED-Gelb ein
          SetBit(LED_Gelb);
        endif;

      endif; // if LED_Rot_Zaehler=0

    endif;  // if LED_Rot_Zaehler>0 then





    ITP3_Server_Abfrage;


    if LED_Weiss_AT24C512_Zaehler>0 then

      DEC(LED_Weiss_AT24C512_Zaehler);

      if LED_Weiss_AT24C512_Zaehler=0 then

        // LED-Weiss_AT24C512 aus
        ClearBit(LED_Weiss_AT24C512);

      endif; // if LED_Weiss_AT24C512_Zaehler=0

    endif;  // if LED_Weiss_AT24C512_Zaehler>0



    if LED_Weiss_W25Q64_Zaehler>0 then

      DEC(LED_Weiss_W25Q64_Zaehler);

      if LED_Weiss_W25Q64_Zaehler=0 then

        // LED-Weiss_W25Q64 aus
        ClearBit(LED_Weiss_W25Q64);

      endif; // if LED_Weiss_W25Q64_Zaehler=0

    endif;  // if LED_Weiss_W25Q64_Zaehler>0




  endloop;




END SPIDISK.
